hdu 3367 Pseudoforest【伪森林】

Pseudoforest

Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others)

Total Submission(s): 1929    Accepted Submission(s): 745

Problem Description

In graph theory, a pseudoforest is an undirected graph in which every connected component has at most one cycle. The maximal pseudoforests of G are the pseudoforest subgraphs of G that are not contained within any larger pseudoforest
of G. A pesudoforest is larger than another if and only if the total value of the edges is greater than another one’s.

Input

The input consists of multiple test cases. The first line of each test case contains two integers, n(0 < n <= 10000), m(0 <= m <= 100000), which are the number of the vertexes and the number of the edges. The next m lines, each line
consists of three integers, u, v, c, which means there is an edge with value c (0 < c <= 10000) between u and v. You can assume that there are no loop and no multiple edges.

The last test case is followed by a line containing two zeros, which means the end of the input.

Output

Output the sum of the value of the edges of the maximum pesudoforest.

Sample Input

3 3
0 1 1
1 2 1
2 0 1
4 5
0 1 1
1 2 1
2 3 1
3 0 1
0 2 2
0 0

Sample Output

3
5

题意:有一个无向图,求它的伪森,要求每一个联通分量最多有一个环,使得伪森林的权值最大

#include<stdio.h>
#include<string.h>
#include<algorithm>
#include<iostream>
using namespace std;
const int maxh=10000+10;
const int maxe=100000+10;
typedef struct Edge
{
    int u,v,w;
};
Edge E[maxe];
int fa[maxh],cir[maxh],n,m;
void init(int num)
{
    for(int i=0;i<=num;i++)
    {
        fa[i]=i;
        cir[i]=0;
    }
}
int find(int x)
{
    if(x!=fa[x])
    fa[x]=find(fa[x]);
    return fa[x];
}
bool cmp(Edge e1,Edge e2)
{
    return e1.w>e2.w;//降序
}
bool Union(int x,int y)
{
    int a=find(x);
    int b=find(y);
    if(a==b)//若存在环
    {
        if(!cir[a])若之在集合不存在环
        {
            cir[a]=1;//标记a所在集合有环
            return true;
        }
        return false;
    }
    else
    {
        if(cir[a]==cir[b]&&cir[b]==1)若a,b所在集合都有环则不能合并
        return false;
        if(cir[a]==1)若只有集合有环则可以合并或都无环则可以合并
        fa[b]=a;
        else
        fa[a]=b;
        return true;
    }
}
int main()
{
    int ans;
    while(~scanf("%d%d",&n,&m)&&(n+m))
    {
        init(n);
        ans=0;
        for(int i=0;i<m;i++)
        {
            scanf("%d%d%d",&E[i].u,&E[i].v,&E[i].w);
        }
        sort(E,E+m,cmp);
        for(int i=0;i<m;i++)
        {
            if(Union(E[i].u,E[i].v))
            ans+=E[i].w;
        }
        printf("%d\n",ans);
    }
    return 0;
}

    

时间: 2024-08-04 15:57:43

hdu 3367 Pseudoforest【伪森林】的相关文章

HDU 3367 Pseudoforest(伪森林)(并查集)

题目连接:http://acm.hdu.edu.cn/showproblem.php?pid=3367 题意:在图论中,如果一个森林中有很多连通分量,并且每个连通分量中至多有一个环,那么这个森林就称为伪森林. 现在给出一个森林,求森林包含的最大的伪森林,其大小通过所有边的权值之和来比较. 分析: 1.一开始想的是:在每个连通分量中求一个最大生成树,然后加一条最大的边,再把每个连通分量算出来的值加起来,但WA了.这并不是最优的,因为还存在这种情况:一个连通分量里最初有两个环,但是伪森林要求最多一个

hdu 3367 最大伪森林(kruskal)

最大伪森林:原图的一个子图,在子图的各个连通分量中至多有一个环,且各边权和最大. 方法:kruskal,只是排序按边权从大到小,合并的时候注意判断是否构成多个环. 1 #include <algorithm> 2 #include <iostream> 3 #include <cstring> 4 #include <cstdio> 5 using namespace std; 6 7 const int N = 10000; 8 const int M =

hdu 3367 Pseudoforest (最小生成树)

Pseudoforest Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others)Total Submission(s): 1526    Accepted Submission(s): 580 Problem Description In graph theory, a pseudoforest is an undirected graph in which every connec

HDU 3367 Pseudoforest 最大生成树

题目来源:HDU 3367 Pseudoforest 题意:每个连通块最多可以有一个环 求最大的森林 思路:考虑最大生成树 如果祖先一样没有环 那就合并 如果祖先不一样 如果2棵树都没有环 合并 如果有1棵树有环 合并 标记该棵树有环 #include <cstdio> #include <cstring> #include <algorithm> using namespace std; const int maxn = 100010; struct edge { i

HDU 3367 Pseudoforest

https://vjudge.net/problem/HDU-3367 题意: 一个伪森林是一个每个连通分量至多有一个环的无向图,给出一个图,图中不包含重边和圈,请你求出这个图的权值最大的伪森林. 思路: 一开始想的是用最大生成树,然后加一条最大的不在生成树中的边,wa了,真是可笑题意都没有理解清楚.题中的图可以是非连通的. 之后看了题解,发现是用并查集的思路,先把边从大到小进行排序,之后对于每一条边,我们看它的两个点a,b. 有2大的种情况: 1.a,b在一个连通分量中,并且他们没有被标记,则

hdu 3367 Pseudoforest(并查集)

题意:求图的一最大联通子图,其中最多包含一个环. 思路:利用求最小生成树的方法(kruskal),排序时从大到小排序.连接时有三种情况: 1.一边有环,一边没有(可能两点已经在同一集合,也可能不在) 2.两边都没有环 3.两边都有环 如图: 1 #include<iostream> 2 #include<cstdio> 3 #include<cstdlib> 4 #include<cstring> 5 #include<string> 6 #in

hdu 3367 Pseudoforest 最大生成树★

1 #include <cstdio> 2 #include <cstring> 3 #include <vector> 4 #include <algorithm> 5 using namespace std; 6 7 const int maxn = 100005; 8 int n, m; 9 struct node 10 { 11 int u, v, c; 12 }g[maxn]; 13 long long ans; 14 int fa[maxn];

【hdu3367】Pseudoforest(伪森林)

http://acm.hdu.edu.cn/showproblem.php?pid=3367 题目大意 伪森林就是一个无向图,这个无向图有多个连通块且每个连通块只有一个简单环. 给你一个无向图,让你找这个图的一个最大生成伪森林(即边权之和最大). 题解 考虑到用Kruscal算法搞最大生成树时,每次加入一条边之前都必须保证边的这两点在之前属于两个连通块,就是为了防止出现环. 即如果加入的边的两点在一个没有环的连通块里的话,就会出现一个环. 那么我们把Kruscal算法改造一下,如果这条边的两点在

(最大生成树) hdu 3367

Pseudoforest Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others)Total Submission(s): 1957    Accepted Submission(s): 756 Problem Description In graph theory, a pseudoforest is an undirected graph in which every connec